#include "list.h"


int len(void *_list) {
    struct LIST *list = *(struct LIST **) _list;
    // printf("here in len\n");
    // printf("len=%d\n", list->size);
    // printf("type=%d\n", list->type);
    // printf("capacity=%d\n", list->capacity);
    return list->size;
}

struct LIST * range(int n) {
    struct LIST *list = malloc(sizeof(struct LIST));
    int *arr = (int *) malloc(n * sizeof(int));
    for (int i = 0; i < n; i++)
        arr[i] = i;
    list->size = n;
    list->type = 0;
    list->capacity = n;
    list->ptr = (void *) arr;
    return list;
}



struct LIST * create_empty_list(int type) {
    struct LIST *list = malloc(sizeof(struct LIST));
    // int *arr = (int *) malloc(n * sizeof(int));
    list->size = 0;
    list->type = type;
    list->capacity = 0;
    // list->ptr = (void *) arr;
    return list;
}

struct LIST * create_empty_list_int(int type) {
    return create_empty_list(type);
}

struct LIST * create_empty_list_bool(int type) {
    return create_empty_list(type);
}

struct LIST * create_empty_list_float(int type) {
    return create_empty_list(type);
}


int index_transform(void *_list, int i) {    
    if (i < 0) {
        i += len(_list);
    }
    return i;
}


// l, r inclusive
struct LIST * list_slice(void *_list, int l, int r) {
    struct LIST *list = *(struct LIST **) _list;
    l = index_transform(_list, l);
    r = index_transform(_list, r);
    int n = r - l + 1;
    struct LIST *new_list = malloc(sizeof(struct LIST));
    void *new_arr;
    void *old_list_ptr = list->ptr;
    // extend capacity
    if (list->type == 0) {
        new_arr = (void *) malloc(n * sizeof(int));
        // copy over old values
        for (int i = 0; i < n; i++) 
            ((int *)new_arr)[i] = ((int *)old_list_ptr)[l+i];
    }
    else if (list->type == 1) {
        new_arr = (void *) malloc(n * sizeof(bool));
        // copy over old values
        for (int i = 0; i < n; i++) 
            ((bool *)new_arr)[i] = ((bool *)old_list_ptr)[l+i];
    }
    else if (list->type == 2) {
        new_arr = (void *) malloc(n * sizeof(double));
        // copy over old values
        for (int i = 0; i < n; i++) 
            ((double *)new_arr)[i] = ((double *)old_list_ptr)[l+i];
    }
    new_list->size = n;
    new_list->type = list->type;
    new_list->capacity = n;
    new_list->ptr = (void *) new_arr;
    return new_list;
}

void append(void *_list, void *value) {
    struct LIST *list = *(struct LIST **) _list;
    
    // capacity not enough
    if (list->size >= list->capacity) {
        void *old_list_ptr = list->ptr;
        void *new_list_ptr;
        // extend capacity
        list->capacity = (list->capacity + 1) * 2;
        if (list->type == 0) {
            new_list_ptr = (void *) malloc(list->capacity * sizeof(int));
            // copy over old values
            for (int i = 0; i < list->size; i++) 
                ((int *)new_list_ptr)[i] = ((int *)old_list_ptr)[i];
        }
        else if (list->type == 1) {
            new_list_ptr = (void *) malloc(list->capacity * sizeof(bool));
            // copy over old values
            for (int i = 0; i < list->size; i++) 
                ((bool *)new_list_ptr)[i] = ((bool *)old_list_ptr)[i];
        }
        else if (list->type == 2) {
            new_list_ptr = (void *) malloc(list->capacity * sizeof(double));
            // copy over old values
            for (int i = 0; i < list->size; i++) 
                ((double *)new_list_ptr)[i] = ((double *)old_list_ptr)[i];
        }
        
        list->ptr = new_list_ptr;
        free(old_list_ptr);
    }
    if (list->type == 0) 
        ((int *)list->ptr)[list->size++] = *(int *) value;
    else if (list->type == 1)
        ((bool *)list->ptr)[list->size++] = *(bool *) value;
    else if (list->type == 2)
        ((double *)list->ptr)[list->size++] = *(double *) value;
    
    // printf("here in append\n");
    // printf("len=%d\n", list->size);
    // printf("type=%d\n", list->type);
    // printf("capacity=%d\n", list->capacity);
}


#ifdef BUILD_TEST
int main()
{
    printf("here\n");
    struct LIST *list = malloc(sizeof(struct LIST));
    int *arr = (int *) malloc(5 * sizeof(int));
    arr[0] = 6;
    arr[1] = 3;
    arr[2] = 9;
    arr[3] = 8;
    list->size = 4;
    list->type = 0;
    list->capacity = 4;
    list->ptr = (void *) arr;
    printf("Len(list) = %d\n", len(list));
    for (int i = 0; i < len(list); i++)
        printf("list->ptr[i]=%d\n", ((int *)(list->ptr))[i]);
    // printf("Len(list) = %d\n", list->size);
}
#endif
