#include "treebasics.h"

union Value parse_value(void* value_ptr, int type_id)
{
    // printf("Enter parse_value");
    union Value uvalue;
    switch (type_id)
    {
        case 0 : 
            uvalue.i = *(int*)value_ptr;
            break;
        case 1 :
            uvalue.b = *(bool*)value_ptr;
            break;
        case 2 :
            uvalue.f = *(double*)value_ptr;
            break;
        case 4 :
            uvalue.l = *(struct LIST**)value_ptr;
            break;
    }
    // printf("Leave parse_value");
    return uvalue;
}

bool uvalue_equal(union Value uvalue1, union Value uvalue2, int type_id)
{
    switch (type_id)
    {
        case 0 : 
            return uvalue1.i == uvalue2.i;
        case 1 :
            return uvalue1.b == uvalue2.b;
        case 2 :
            return uvalue1.f == uvalue2.f;
    }
}

bool uvalue_lt(union Value uvalue1, union Value uvalue2, int type_id)
{
    switch (type_id)
    {
        case 0 : 
            return uvalue1.i < uvalue2.i;
        case 1 :
            return (int)uvalue1.b < (int)uvalue2.b;
        case 2 :
            return uvalue1.f < uvalue2.f;
    }
}
