#ifndef DICTSET_H
#define DICTSET_H

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include "list.h"

#define is_left_child(x) (x->parent->lc == x)

union Value
{
    int i;
    float f;
    bool b;
    struct LIST* l;
};

struct TreeNode
{
    union Value key;
    union Value value;
    struct TreeNode* parent;
    struct TreeNode* lc;
    struct TreeNode* rc;
};

union Value parse_value(void* value_ptr, int type_id);

bool uvalue_equal(union Value uvalue1, union Value uvalue2, int type_id);

bool uvalue_lt(union Value uvalue1, union Value uvalue2, int type_id);

#endif
